/***************************************************************/
/***							     ***/
/*** Modifica del contenuto dei campi della card selezionata ***/
/***							     ***/
/***************************************************************/

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#ifndef SUB_CALLING
#  include <gtk/gtk.h>
#  include <stdio.h>
#  include <string.h>
#  include <malloc.h>
#  include <unistd.h>
#  include <sys/types.h>
#  include <sys/stat.h>
#  include <fcntl.h>
#  include "callbacks.h"
#  include "interface.h"
#  include "support.h"
#  include "pfunc.h"
#  include "sfunc.h"
#  include "mfunc.h"
#  include "telefono.h"
#  include "iofile.h"
#endif


void
on_modifica_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
 int i;
 GtkWidget * text;

 if( Status[S_RUBRICA] )
 {
  Modifica = create_modifica();
  text = lookup_widget (GTK_WIDGET (Modifica), "card_preview");
  gtk_text_set_word_wrap(GTK_TEXT(text), 1);

  Status[S_SELCAMPO] = -1;	/* Nessun campo  selezionato */
  Status[S_CMPMOD] = 0;		/* Nessun campo ancora modificato */
  Status[S_CRDMOD]++;		/* Un'altra card modificata */
  g_print("\nStatus[S_CAMPI]=%d", Status[S_CAMPI]);
  for(i = COD; i < Status[S_CAMPI]; i++)
  {
   ContenutoCampi[i] = M_STRDUP( trova_campo_da_lista(Lista[Status[S_SELISTA]] ,i) );
   g_print("\nContenutoCampi[%d]=\"%s\"", i, ContenutoCampi[i]);
  }
  imposta_listacampi(Modifica, "listacampi");

  CardCopia = (struct card *)malloc(sizeof(struct card));
  crea_card_da_campi(CardCopia, ADATTA_CARD);
  stampa_card(CardCopia, Modifica, "card_preview");
  set_vscroll_window(Modifica, "scrolledwindow7", 0);

#ifdef HIDE
  gtk_widget_hide (Base);
#endif
  gtk_widget_set_sensitive (Base, FALSE);
  MOSTRA_ON_MOUSE (Modifica);
 }
 else
  show_error_msg("ERRORE: nessuna rubrica e` caricata: apri un file di rubrica.");
}


void
on_button_modifica_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
 on_modifica_activate (NULL, user_data);
}


gboolean
on_modificatext_key_press_event        (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{
 int key;
 GtkList * glst;

 key = g_whats_key(event);
 g_print("\nKey 0x%x pressed on Modifica Box", key);
 switch( key )
 {
  case KEYB_INVIO:
	if(Status[S_CONFMOD])
	{
	 on_ok_modifica_clicked (NULL, user_data);
	 g_print(": Modifica apportata");
	}
	if(Status[S_SELCAMPO]+1 < Status[S_CAMPI])
	{
	 glst = GTK_LIST( lookup_widget (Modifica, "listacampi") );	
	
	 /* questa chiamata emette un segnale che aggiorna
	    Status[S_SELCAMPO]++ in modo automatico */
	 gtk_list_select_item( glst, Status[S_SELCAMPO]);		
	 g_print("\nSet listacampi item n.%d",Status[S_SELCAMPO]);
	
	 set_scrolled_window(Modifica, "scrolledwindow5", "listacampi", ON_PAGE);
	}
	break;

  case KEYB_I:
	if(Status[S_KEYSHIFT] == KEYB_CTRL)
   	 stampa_infos();
   	else
   	 Status[S_CONFMOD] = 1;
  	break;

  case KEYB_CTRL:
   	Status[S_KEYSHIFT] = KEYB_CTRL;
   	break;

  default:
   	Status[S_CONFMOD] = 1;
  	break;
 }		

 return FALSE;
}


void
on_ok_modifica_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
 GtkWidget * entry;
 gchar * strn;
 char * old_card;

 Status[S_CONFMOD] = 0;
 if(Status[S_SELCAMPO] == -1)
 {
  show_error_msg("ERRORE: nessun campo selezionato: seleziona un campo nella lista.");
  return;
 }

 entry = lookup_widget (GTK_WIDGET (Modifica), "modificatext");
 strn = g_strdup_printf ("%s",gtk_entry_get_text(GTK_ENTRY (entry)));

 g_print("\nStringhe: %s <--> %s", strn, ContenutoCampi[Status[S_SELCAMPO]]);
 if( !strcmp((char *)strn, ContenutoCampi[Status[S_SELCAMPO]]) )
  return;
 else
 {
  if( Status[S_SELCAMPO] == COG || Status[S_SELCAMPO] == NOM )
   Status[S_CMPMOD] = 1 + Status[S_SELCAMPO];
  else if(!Status[S_CMPMOD])
   Status[S_CMPMOD] = 1;
 }

 if( !strcmp((char *)strn,"") )
 {
  sprintf(ContenutoCampi[Status[S_SELCAMPO]],"_");
  g_print("\nmodificatext: *NULL*");
 }
 else
 {
  M_FREE(ContenutoCampi[Status[S_SELCAMPO]]);
  ContenutoCampi[Status[S_SELCAMPO]] = (char *)strn;

  g_print("\nmodificatext: %s", ContenutoCampi[Status[S_SELCAMPO]]);
 }

 old_card = CardCopia->cod;
 crea_card_da_campi(CardCopia, ADATTA_CARD);
 if(old_card != NULL);
 {
  free(old_card - 1);
  old_card = NULL;
 }

 stampa_card(CardCopia, Modifica, "card_preview");
 set_vscroll_window(Modifica, "scrolledwindow7", 0);
}


void
on_listacampi_select_child             (GtkList         *list,
                                        GtkWidget       *widget,
                                        gpointer         user_data)
{
 int ps;

 /* Ho preferito il piu` generico widget parametro passato
    dalla funzione invece che Modifica il puntatore globale*/
 ps = seleziona_campo_in_lista(widget, "listacampi");

 /* Evito anche di chiamare la funzione quando e` palesemente inutile */
 if(ps >= 0)
  scrivi_modifica_campo(widget, "modificatext", Status[S_SELCAMPO]);
}


void
on_conferma_modifica_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{
 int i;
 struct card * rc;

 /* La conferma deve attuare la modifica effettuata */

 if(Status[S_CONFMOD])
 {
  on_ok_modifica_clicked (NULL, user_data);
  g_print("\nModifica confermata (on_conferma_modifica_clicked) %d", Status[S_SELISTA]);
 }

 /* Se in futuro servira` non si dovra stampare per una
    lunghezza arbitraria ma solo inferiore a quella della card 
 g_print("\nPreview della card:\n");
 for(i = 0; i < 100; i++)
 {
  int ch;
  ch = Lista[Status[S_SELISTA]]->cod[i];
  if(ch)
   g_print("%c", ch);
  else
   g_print("\\0");
 }
 g_print("\n");
 */

 /* Ora questa nuova card la devo linkare alle altre
    sempre che sia stata cambiata */
 if(Status[S_CMPMOD])
 {
  CardCopia->cog = trova_campo_da_lista(CardCopia, COG);
  CardCopia->nom = trova_campo_da_lista(CardCopia, NOM);
  CardCopia->nxt = Lista[Status[S_SELISTA]]->nxt;

  i = 0;
  rc = Primo;
  while(rc->nxt != Lista[Status[S_SELISTA]]->nxt && i < Status[S_CARDS])
  {
   i++;
   rc = rc->nxt;
  }
  rc->nxt = CardCopia;
  if( i >=  Status[S_CARDS])
   g_print("\nERROR: ricerca aggancio modified card fallita");

  Lista[Status[S_SELISTA]] = CardCopia;
 }

 g_print("\nContenuto(%d): %s, %s", Status[S_SELISTA], Lista[Status[S_SELISTA]]->cog, Lista[Status[S_SELISTA]]->nom);

 for(i = 0; i < MAX_N_CAMPI; i++)
  M_FREE(ContenutoCampi[i]);

 gtk_widget_hide(Modifica);
 gtk_widget_set_sensitive (Base, TRUE);
#ifdef HIDE
 gtk_widget_show (Base);
#endif
 

 if(Status[S_CMPMOD] > 1)
 {
  Status[S_MODIFICA] = 1;
  g_print("\nStatus SELISTA: %d",  Status[S_SELISTA]);
  /* Quando si cambia il nome o cognome ad una persona
     e` possibile che al ritorno nella lista non sia piu`
     selezionato questo serve per stampare la card giusta */
  imposta_lista();
  set_sensitive_tools(IF_NEED);
 }
 else if(Status[S_CMPMOD])
 {
  Status[S_MODIFICA] = 1;
  set_lista_item(Status[S_SELISTA], !S_INIBIT);
  set_sensitive_tools(IF_NEED);
 }
}


void
on_annulla_modifica_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
 gtk_widget_hide(Modifica);

 /* Prima vi era il codice della funzione chiamata
    ma l'ho sostituito con la chiamata alla funzione */

 /* on_modifica_destroy (NULL, user_data); */

   ANNULLA_MODIFICHE_CAMPI();
   gtk_widget_set_sensitive (Base, TRUE);
#ifdef HIDE
   gtk_widget_show (Base);
#endif
}


void
on_modifica_destroy               (GtkObject       *object,
                                   gpointer         user_data)
{

 if(Status[S_AVVRTM] != AVT_DESTROYB)
 {
  /* E` prioritario salvare le modifiche della
     finestra base altrimenti si possono salvare
     anche le modifiche della finestra di editing */

  Modifica = NULL;
  if( Status[S_CMPMOD] )
   chiudi_con_modifiche(Modifica, AVT_DESTROYM);
  else
  {
   ANNULLA_MODIFICHE_CAMPI();
   gtk_widget_set_sensitive (Base, TRUE);
#ifdef HIDE
   gtk_widget_show (Base);
#endif
  }
 }
}


gboolean
on_modificatext_key_release_event      (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{
 int key;

 key = g_whats_key(event);
 if(key == KEYB_CTRL)
   Status[S_KEYSHIFT] = 0;

 return FALSE;
}

void
on_modificatext_clipboard              (GtkEditable     *editable,
                                        gpointer         user_data)
{
 Status[S_CONFMOD] = 1;
 g_print("\nClipboard on Modifica Box");
}

void
on_modificatext_text                   (GtkEditable     *editable,
                                        gchar           *new_text,
                                        gint             new_text_length,
                                        gint            *position,
                                        gpointer         user_data)
{
 if(Status[S_INIBIT] != S_LISTA)
 {
  Status[S_CONFMOD] = 1;
  g_print("\nModifica Box text changed");
 }
}
