#ifndef SUB_CALLING
 #include <stdio.h>
 #include "callbacks.h"
 #include "pfunc.h"
 #include "sfunc.h"
 #include "mfunc.h"

 #include <string.h>
 #include <stdlib.h>
 #include <unistd.h>
#endif


void ApriFileByName(char * const name)
{
 int len, k, i;
 char text[TXT_LUN];

 if ( !access(name,R_OK | F_OK) )
 {
  g_print ("\nTry to open as input files: ");

  if( name != NomeFile )
  {
   M_FREE(NomeFile);
   NomeFile = M_STRDUP(name);
  }
  len = strlen(NomeFile);

  /* Comincio una serie di controlli sulla validita` del file selezionato */
  if( NomeFile == NULL || NomeFile[len-1] == '/')	
   g_print ("none");					/* Le directory sono escluse */
  else
  {
   g_print ("%s", NomeFile);

   k = 0;
   for (i = 0; i < strlen(NomeFile); i++)
   {
    if (NomeFile[i] == '/' )
     k = i;
   }
   if ( k ) k++;

   M_FREE(SoloNomeFile); SoloNomeFile = M_STRDUP( &(NomeFile[k]) );

   sprintf(text,"Rubrica: \"%s\"", SoloNomeFile);
   g_set_window_title (Base, text);

   sprintf(text,"Reading %s", NomeFile);
   g_set_statusbar (Base, text);

   /* Leggo il file e controllo che sia letto correttamente */
   if( !leggi_rubrica() )				
   {
    sprintf(text,"Loading %s", NomeFile);
    g_set_statusbar (Base, text);

    carica_rubrica();
    if (Status[S_RICERCA])
    {
     Status[S_INIBIT] = S_RICERCA;
     set_ricerca("");
    }
    /* Questa riga risolve il problema della modifica 
       del primo campo selezionato ma non stampato */
    set_lista_item(0, !S_INIBIT);

    sprintf(text,"Nominativi inseriti: %d ",Status[S_CARDS]);
    g_set_statusbar (Base, text);

    if (Status[S_CAMPI] < 1)
     g_print("\nERROR: acquisizione campi di intestazione riporta %d",k);
   }
  }
 }
 else
  g_print("\nFile %s non esiste oppure non hai il permesso per leggerlo", name);
}


/* In caso di errore nell'aprire il file
   Occorre inizializzare Rubrica Italiana
   come se la si fosse appena lanciata */
#define LR_ERROR_EXIT(testo) {		\
  fclose(fp);				\
  RESTART_BASE();			\
  show_error_msg(testo);		\
}					
int leggi_rubrica(void)
{
 FILE * fp;
 size_t lu;
 long l;

 g_print ("\nReading rubrica file (continua)");

 fp = fopen(NomeFile, "rt");   				/* apre per leggere */
 FileBufferLun = (unsigned long)getfilelenght(fp);	/* misura la lunghezza del file */
 g_print (" of %ld bytes lenght", FileBufferLun);

 free_memory();

 if (MAX_FILE_LUN < FileBufferLun)			/* controlla che la lunghezza del file */
 {							/* sia inferiore a quella massima consentita */
  FileBuffer = (char *)malloc(MAX_FILE_LUN+10);
  g_print (" exceed");

  LR_ERROR_EXIT("ERRORE: il file selezionato ha una dimensione troppo grande.");
  return -1;
 }
 else
 {
  FileBuffer = (char *)malloc(FileBufferLun+10);	/* alloca la memoria per leggere la rubrica +10 bytes*/
  if(FileBuffer != NULL)				/* Controlla che effettivamente l'allocazione */
   g_print (" allocated\n");				/* della memoria sia riuscita */
  else
  {
   LR_ERROR_EXIT("ERRORE: non riesco ad allocare la memoria necessaria");
   return -2;
  }

  lu = fread(FileBuffer, 1, FileBufferLun, fp);		/* legge il file che contiene la rubrica */
  if (lu != (size_t)FileBufferLun)			/* controlla che sia riuscita la lettura */
  {
   LR_ERROR_EXIT("ERRORE: non riesco a leggere il file selezionato.");
   return -3;
  }

  l = find_first(FileBuffer, "#seq: \"", IGN_CASE | REVERSE);
  if(l < 0L)
  {
   LR_ERROR_EXIT("ERRORE: il file selezionato non sembra essere una rubrica valida.");
   return -4;
  }
 }

 /* Chiudo il file dopo averne copiato il
    contenuto in memoria ed esco senza errore */
 Status[S_BUFFER] = 1;
 fclose(fp);    					

 return 0;
}


char * file_backup_name(const char * nomefile)
{
 int i, status;
 char * str1, * str2;

 i = 0;
 str1 = M_STRDUP(nomefile);
 if( access(str1, F_OK) )
  return NULL;

 do {
  str2 = (char *)malloc(strlen(str1) + 5);
  sprintf(str2,"%s.bak", str1);
  M_FREE(str1);
  str1 = str2;
  status = access(str1, F_OK);
  i++;
 }
 while( !status && i < MAX_BACK_COUNT);

 if( i >= MAX_BACK_COUNT )
 {
  str2 = (char *)malloc(strlen(str1) + 5);
  sprintf(str2,"-f %s", str1);
  M_FREE(str1);
 }
 return str2;
}


int file_copy(char * const nomefile, char * const backfile)
{
 int status;
 char * str;

 if( access( nomefile, R_OK ) )
 {
  /* Con le nuove funzioni di "Salva con nome" e di creazione
     della rubrica questo allarme non e` piu` sostenibile
     show_error_msg("\nERRORE: nel fare il backup il file sorgente non  leggiible"); */
  return -1;
 }

 g_print("\nBackup %s %s", nomefile, backfile);
 str = (char *)malloc(strlen(nomefile) + strlen(backfile) + 8);
 sprintf(str, "cp %s %s", nomefile, backfile);
 status = system(str);
 M_FREE(str);

 if(status == 127 || status == -1)
  return -3;
 else
  return 0;
}


unsigned long getfilelenght(FILE * fp)
{
 long lun;

 fseek( fp, 0, SEEK_END);
 lun = ftell(fp);
 rewind(fp);

 return lun;
}
