#ifndef SUB_CALLING
 #include <stdio.h>
 #include "callbacks.h"
 #include "pfunc.h"
 #include "sfunc.h"
 #include "mfunc.h"
#endif


/* Questa puo` essere fusa con la set_lista_item
   in una funzione molto piu` generale */
void set_listacampi_item(int k)
{
 GtkList * glst;
 GtkWidget * list;

 if ( k > 0 )
 {
  g_print("\nSet listacampi item n.%d", k);
  list = lookup_widget (Creazione, "listacreacampi");
  glst = GTK_LIST( list );	
  gtk_list_select_item( glst, k-1);				

  Status[S_SELCAMPO] = k;
  set_scrolled_window(Creazione, "scrolledwindow9", "listacreacampi", ON_PAGE);
 }
}

int seleziona_campo_in_lista(GtkWidget * widget, const char * widget_name)
{
 int cd = -1;
 GtkWidget   * lst;
 GList       * dlist;
 GtkObject   * list_item;
 gchar       * item_data_string;

 g_print("\nSeleziona campo in lista started (%d)", Status[S_CONFMOD]);

 lst = lookup_widget (GTK_WIDGET (widget), widget_name);
 dlist = GTK_LIST(lst)->selection;
 item_data_string = NULL;
 while (dlist)
 {
  list_item = GTK_OBJECT(dlist->data);
  item_data_string = gtk_object_get_data(list_item, list_item_data_key);
  cd = atoi(item_data_string);

  dlist=dlist->next;
 }

 /* Questo condizione serve per evitare la     */
 /* ripetizione del codice dopo l'impostalista    */
 /* che non cambia la selezione ma lancia un segnale */
 if(cd != Status[S_SELCAMPO] && cd >= 0)	
 {
  if(Status[S_CONFMOD])				
  {
   Status[S_CONFMOD] = 0;
   g_print("\nModifica clicked call");
   on_ok_modifica_clicked (NULL, NULL);
   g_print("\nModifica confermata (%s)", widget_name);
  }
  Status[S_SELCAMPO] = cd;			
  g_print("\nLista campi changed (%d)", Status[S_SELCAMPO]);
 }
 else if(cd < 0)
  g_print("\nERROR: selected invalid list child");
 else
 {
  g_print("\nSaltato un segnale inutile");
  cd = -1;
 }

 return cd;
}


void imposta_listacampi(GtkWidget *widget, const char * widget_name)
{
 int i;
 GtkWidget * list, * list_item;
 GList     * dlist;

 g_print("\nImposta lista campi started");

 dlist = NULL;
 for (i = 1; i < Status[S_CAMPI]; i++)	  				/* Scrittura degli elementi della lista   */
 {									/* il codice non e` un campo modificabile ed obbligatorio, quindi viene inizializzato in modo unico alla creazione di una nuova card */
  if(Campi[i] != NULL)
  {
//   g_print("\nERRORE: Il puntatore Campi[%d] e` NULL (%d)", i, Status[S_CAMPI]);
//   return;
//  }

   list_item = gtk_list_item_new_with_label(M_STRDUP(Campi[i]));
   dlist = g_list_append(dlist, list_item);
   gtk_widget_show(list_item);
   gtk_object_set_data(GTK_OBJECT(list_item), list_item_data_key, IndexCampi[i]);
  }
 }

 list = lookup_widget (GTK_WIDGET (widget), widget_name);		/* Visualizzazione del contenuto della lista */
 if(Status[S_CAMPI] > 0)
  gtk_list_clear_items (GTK_LIST(list), 0, Status[S_CAMPI]);           	/* Questa riga l'ho aggiutna dopo 10-08-2000 */

 for (i = 1; i < Status[S_CAMPI]; i++)
  if(Campi[i] != NULL) 
   g_print("\nCampo %2s: %s (%lx) = %s (%lx)", IndexCampi[i], Campi[i], (long)Campi[i], ContenutoCampi[i], (long)ContenutoCampi[i]);
 g_print("\nFin qua forse tutto bene %d", Status[S_SELCAMPO]);

 Status[S_CONFMOD] = 0;
 /* Questa riga fa partire la selezione del primo campo della lista
    ma lo status di inibizione impedisce che sia elaborato ma
    nonostante questo occorre riallineare lo stato con un set item */
 /*Status[S_SELCAMPO] = 1;*/
 Status[S_INIBIT] = S_LISTA;
 gtk_list_append_items(GTK_LIST(list), dlist);
 Status[S_INIBIT] = -1;

 /* Nel caso della finestra di modifica questo non serve */
 if(widget == Creazione)
  set_listacampi_item( (Status[S_SELCAMPO] < 0) ? 1 : Status[S_SELCAMPO]);

 /* Questo invece serve per avere lo scroll giusto al ritorno 
    ma ovviamente funziona solo fino a quando le modifiche non 
    decretano un nuovo ordinamento dei nominativi 
 set_lista_item((Status[S_SELISTA] < 0) ? 0 : Status[S_SELISTA], !S_INIBIT); */

 /*
 else
  set_lista_item(Status[S_SELCAMPO], S_INIBIT);
 */


 g_print("\nImposta lista campi on %s returned", widget_name);
}


void scrivi_modifica_campo(GtkWidget * widget, const char * widget_name, int cmp)
{
 char * txt; 

 g_print("\nScrivi su %s (%d, %d), ", widget_name, Status[S_CONFMOD], cmp);
 if(cmp > 0 && cmp < Status[S_CAMPI])
 {
  txt = M_STRDUP(ContenutoCampi[cmp]);
  g_print("ContenutoCampi: \"%s\"", txt);
  if( !strcmp(txt, "_") )
   txt[0] = 0;

  /* Questo codice una volta era la funzione
     void set_modifica(const char * strn)
     per aiuto ho mantenuto lo scope di *entry */
  {
   GtkWidget * entry;

   entry = lookup_widget (GTK_WIDGET (widget), widget_name);

   /* txt viene allocato dinamicamente e non viene rilasciato
      con un del_text quindi si verifica un memory leak */

   gtk_entry_set_text(GTK_ENTRY (entry), txt);
  }
 }
}


char * trova_campo_da_lista(struct card * lst, int cmp)
{
 int k, i;
 char * str;

 /* Questa funzione deve essere adattata al fatto che
    alcuni campi aggiunti potrebbero essere fittizi ma
    ormai dovrei essermi assicurato che ogni nuovo campo
    sia inizializzato ad un valore vuoto  */

 k = 0;
 str =  lst->cod;
 for ( i = 0; i < cmp; i++)
 {
  while(str[k]) 	/* trova la fine di un campo */
   k++;

  while(!str[k])	/* trova l'inizio dell'altro */
   k++;
 } 

 return &str[k+1];
}


void crea_card_da_campi(struct card * crd, int adatta) 
{
 int i, leng, index_nom, index_cog;
 char * new_card;

 leng = 0;
 for(i = 0; i < Status[S_CAMPI]; i++)
  leng += strlen(ContenutoCampi[i]);
 leng += 4*Status[S_CAMPI] + 1;
 new_card = (char *)malloc(leng);

 sprintf(new_card, "\"#%s\"",ContenutoCampi[COD]);
 index_cog = strlen(new_card) - 1;

 sprintf(new_card, "%s\t\"%s\"", new_card, ContenutoCampi[COG]);
 index_nom = strlen(new_card) - 1;

 for(i = NOM; i < Status[S_CAMPI]; i++)
  sprintf(new_card, "%s\t\"%s\"", new_card, ContenutoCampi[i]);

 /* La card generata pu servire anche a sostituirne una in memoria,
    ma potrebbe essere preparata per essere scritta su file */

 if(adatta == ADATTA_CARD)
 {
  /* Il carattere # serve per concludere la card, mentre il carattere \0
     non permette che sia stampato   */
  sprintf(new_card, "%s%c#", new_card, 0);
 
  /* Questo codice dovrebbe uniformare la card ad una gi elaborata 
     evita la comparsa di doppi '"' alla seconda modifica dovuta 
     alla non trasformazione dei \t in \0 da parte della funzione 
     di stampa.   */
  new_card[strlen(new_card)] = 0; 
  for(i = 0; i < leng; i++)
   if(new_card[i] == '\t')
   {
    new_card[i-1] = 0;
    new_card[i] = 0;
   }
 }
 else if(adatta != FILE_CARD)
  g_print("ERROR: il tipo di card non  stato specificato corettamente (%d)", adatta);

 crd->num = atoi(ContenutoCampi[COD]);
 crd->cod = &new_card[1];
 crd->cog = &new_card[index_cog];
 crd->nom = &new_card[index_nom];
 /*crd->nxt = NULL; 			 in generale questo dovr essere inizializzato */
}


int get_new_code(int * code, int * last_lst)
{
 int max, i, prv, c, ret = 0;

 c = 0;
 prv = -1;
 /* max = Lista[0]->num; */
 max = -1;
 for(i = 0; i < Status[S_CARDS]; i++)
 {
  if(Lista[i]->num > max)
   max = Lista[i]->num;

  if(Lista[i]->nxt == NULL)
  {
   c++;
   prv = i;
  }
 }
 if(max == 0)
 {
  g_print("\nERROR: new code searcing not correct value %d", max+1);
  ret = -2;
 }
 max++;

 if(c > 1 || prv < 0)
 {
  g_print("\nERROR: new code searcing not correct value %d (%d,%d)", max, c, prv);
  ret = -1;
 }

 *code = max;
 *last_lst = prv;
 return ret;
}


int create_n_link_new_card(int new_cod, int last_lst)
{
 int i, len;
 char * buf;
 struct card * crd;

 len = 10 + Status[S_CAMPI]*4;
 buf = (char *)malloc( len );
 crd = (struct card *)malloc( sizeof(struct card) );

 g_print(" len = %d", len);
 
 sprintf(buf,"\"#%s%s%d\"\t", (new_cod < 100) ? "0" : "", (new_cod < 10) ? "0" : "", new_cod);
 for(i = 0; i < Status[S_CAMPI]; i++)
  sprintf(buf, "%s\"_\"\t", buf);
 sprintf(buf, "%s\"#", buf);

 if(strlen(buf) > len-1)
  g_print("\nERROR: calculated lenght was short !");

 /* Questo adatta la nuova card a quelle in memoria */
 buf[5] = 0;
 buf[9] = 0;
 buf[13] = 0;
 for(i = 0; i < len; i ++)	
  if( buf[i] == '\t')
   buf[i] = 0;

 /* Inizializza e lega la nuova card */
 crd->num = new_cod;
 crd->cod = &buf[1];
 crd->cog = &buf[8];
 crd->nom = &buf[12];
 crd->nxt = NULL;
 Lista[last_lst]->nxt = crd;
 Lista[Status[S_CARDS]] = crd;
 Status[S_CARDS]++;

 return Status[S_CARDS]-1;
}

