#ifndef SUB_CALLING
 #include <stdio.h>
 #Include <string.h>
 #include "callbacks.h"
 #include "pfunc.h"
 #include "sfunc.h"
#endif


char * sequenza_stampabile(char * const seq)
{
 char * str;
 int i;

 /* Elimino il tag #seq: e gli apici doppi 
	all'inizio e alla fine della sequenza */
 
 i = 0; while(seq[i] != '"') i++;
 str = M_STRDUP(&seq[i+1]);
 i = strlen(str)-1; while(str[i] != '"') i--;
 str[i] = 0;
 
 g_print("\nStampabile started, cuore della Sequenza:\n%s", str);
 str = formatta_testo(str);

 return str; 
}


/* Questa funzione ritorna un intero negativo se avviene un errore
   altrimenti riporta un positivo che e` pari al numero di campi
   trovati nell'intestazione del file */
int get_intestazione(void)
{
 long i, ln;
 int k, j;

 i = 0; while (FileBuffer[i] != '#' && i < FileBufferLun) i++; 
  if(i > FileBufferLun)
   return -1;
 ln = i-2;								/* Altrimenti come nome di campi si include anche il primo codice */

 k = 0; 
 for( i = 0; i < ln && k < MAX_N_CAMPI; i++)
  if (FileBuffer[i] == '"')
  {
   if (Campi[k] != NULL) M_FREE(Campi[k]);	/* Libero il puntatore */
   Campi[k] = &(FileBuffer[i+1]);
   j = 0; while (Campi[k][j] != '"') j++;	/* Si occupa di eliminare il carattere '"' */
   Campi[k][j] = 0;                         	/* in fondo alla stringa */
   Campi[k] = M_STRDUP(&FileBuffer[i+1]);
   
   i += j;								/* Passa ad analizzare dopo la stringa */
   k++;
  }

 for(i = 0; i < k; i++)
  g_print("\ncampo %2ld: %s",i,Campi[i]);

 if (k == MAX_N_CAMPI)
  return -2;
 else
  return k;
}


int get_formato_card(char * const seqnz)
{
 int a, i, j, k, st, ed, cmd, lung;
 char * str, * ostr;
 struct stringa * tx;

 g_print("\nInizio get_formato_card()");
 
 /* Non posso permettermi di corrompere la 
    stringa che mi viene passata in input */
 if(seqnz == NULL)
 {
  g_print("ERRORE IRRECUPERABILE: il formato della sequenza ha trovato nullo il puntatore");
  return -1;
 } 
 ostr = M_STRDUP(seqnz); 

 /* Devo mantenere il puntatore originale
    per poter deallocare il buffer */
 str = ostr;
 i = 0; while(str[i] != '"') i++;
 str = &str[i+1];
 st = 0;

 i = st+1; while(str[i] != '"') i++;
 str[i] = 0;
 ed = i;
 // g_print("\nTi mostro la sequenza purgata:\n%s", str);


 /* Inizializzazione del ciclo while con un occhio di
    riguardo di controllare se si comincia con un campo 
    oppure con del testo */
 if(str[st] == '%') 
 {
  cmd = 1;
  i = 1;
 }
 else
 {
  cmd = 0;
  i = 0;
 }
 tx = &Carta;
 lung = 0;

 g_print(" ed:%d", ed);
 while (i < ed)
 {
  /* Trova il primo (o il secondo se la sequenza cominciava con '%') carattere '%' */
  j = i;
  while (str[i] != '%' && i < ed) i++;
  if( i < ed ) str[i] = 0;
  g_print(" %d", i);
  
  /* Facendo attenzione a non uscire dalla sequenza  mi occupo di salvare in casi 
     alterni il testo e il numero del campo che adra` sostituito con il suo contenuto
     quando decidero` di visualizzare un nominativo */
  if( !cmd )
  {
   tx->camp = -1;
   tx->text = (char *) M_STRDUP (&str[j]);
   tx->next = (struct stringa *) malloc( sizeof(struct stringa) );
   lung += strlen( tx->text );  
 
   tx = tx->next;	/* Inizializzazione del puntatore */
   tx->next = NULL;	
   cmd = 1;
  }
  else
  {
   g_print("#"); 
   cmd = -1;
   for(k = 0; k < Status[S_CAMPI] && k < MAX_N_CAMPI; k++) 
   {
    if(Campi[k] != NULL)
     a = strcasecmp(&str[j],Campi[k]); 
    else 
    {
     a = -1;
     cmd = 0;
    } 
     
    if( !a )
    {
     tx->camp = k;
     tx->text = NULL;
     tx->next = (struct stringa *) malloc( sizeof(struct stringa) );

     tx = tx->next;	/* Inizializzazione del puntatore */
     tx->next = NULL;	
     cmd = 0;
     k = MAX_N_CAMPI;	/* esce dal ciclo */
    }
   }

   if (cmd == -1)
   {
    g_print("\nERROR: Questo non e` un campo corretto (%s)", &str[j]);
    cmd = 0;
   }
  }
  i++;
 }

 g_print(" fine %d", i);
 M_FREE(ostr);
 return lung;
}


void stampa_card(struct card * rc, GtkWidget * form, const char * name)
{
 int i, j, k, ncmp, tlun, ln, lun;
 char * str, * outxt;
 char * out[MAX_N_CAMPI];

 /* Inizializzo i puntatori */
 for( k = 0; k < MAX_N_CAMPI; k++)
  out[k] = NULL;

 str = rc->cod - 1;
 g_print("\nStampa %s card started ", &str[1]);

 i = 2; while (str[i] != '#' && i < MAX_RECORD_LUN) i++; 
  if(i > MAX_RECORD_LUN)
   g_print("ERROR: troppo avanti mi sono spinto!");
 lun = i-2;	

 k = 0;
 tlun = 0;
 for( i = 0; i < lun && k < MAX_N_CAMPI; i++)
  if (str[i] == '"')
  {
   out[k] = &(str[i+1]);
   ln = strlen(out[k]);

   j = 1; while(out[k][j] != '"' && out[k][j]) j++;	/* Solo la prima volta che si stampa questa card */
   if (out[k][j] == '"')				/* toglie il caratter '"' in fondo al campo      */
    out[k][j] = 0;					/* le succesive incontra lo zero e non fa nulla  */
   i += j;						/* In ogni caso procede scansionando il resto    */

   tlun += ln+20;				        /* Il testo finale dovra essere piu` lungo della  
   tlun += strlen(Campi[k]); 	   			   somma di tutti i campi e del i loro titoli    */
   k++;
  }
 ncmp = k;
 tlun += ncmp*4 + LungIntst;

 outxt = crea_testo(tlun, out);
 outxt = formatta_testo(outxt);
 set_testo(outxt, form, name, TXT_REPLACE);
 M_FREE(outxt);
}


int estrai_campi_da_card(struct card * rc, char ** out)
{
 int i, j, k, ln, lun;
 char * str;

 str = rc->cod - 1;

 i = 2; while (str[i] != '#' && i < MAX_RECORD_LUN) i++; 
  if(i > MAX_RECORD_LUN)
   g_print("\nERRORE: troppo avanti mi sono spinto!");
 lun = i-2;	

 k = 0;
 for( i = 0; i < lun && k < MAX_N_CAMPI; i++)
  if (str[i] == '"')
  {
   out[k] = &(str[i+1]);
   ln = strlen(out[k]);

   j = 1; while(out[k][j] != '"' && out[k][j]) j++;	/* Solo la prima volta che si lavora questa card */
   if (out[k][j] == '"')				/* tglie il caratter '"' in fondo al campo */
    out[k][j] = 0;					/* le succesive incontra lo zero e non fa nulla */
   i += j;						/* In ogni caso procede scansionando il resto */

   k++;
  }

 /* Questo codice e` stato aggiunto per supplire alla
    mancanza di contenuto per i nuovi campi aggiunti ora ora */
 while( k < Status[S_CAMPI] )
 {
  g_print("\nSupplisco alla carenza di dati con puntatori nulli (%d)", k);
  out[k] = NULL;
  k++;
 }

 return k;
}


char * crea_testo(int tlun, char ** out)
{
 int k;
 struct stringa * cr;
 char * outxt;

 outxt = (char *)malloc( tlun );
 if (outxt == NULL)
  g_print("\nERROR: output text buffer not allocated");
 else
  g_print("\nOutext card allocated in %d bytes", tlun);

 k = 0; 
 cr = &Carta;
 outxt[0] = 0;
 while (cr->next != NULL && k < 2*MAX_N_CAMPI+1)
 {
  if (cr->camp < 0)
   sprintf(outxt,"%s%s", outxt, cr->text);
  else if(out[cr->camp] != NULL)
  {
   /* Se il campo e` stato appena aggiunto da modella 
      non avra` contenuto e il suo puntatore e` nullo */
   if( strcmp(out[cr->camp], "_") && strlen(out[cr->camp]) > 0)
    sprintf(outxt,"%s%s", outxt, out[cr->camp]);
  }
  cr = cr->next;
  k++;
 }

 return outxt;
}


char * formatta_testo(char * intxt)
{
 int i, l, k, mng;

 l = strlen(intxt);
 for(i = 0; i < l; i++)
 {
  mng = 0;
  if (intxt[i] == '\\')
  {
   switch(intxt[i+1])
   {
    case '%':
    case '#':
    case '\\':
    case '"':	mng = 1;
		break;

    case 'N':
    case 'n':	mng = 1;
		intxt[i+1] = 10;
		break;

    case '0':	mng = 2;
		break;

    default:	mng = 0;
		break;
   }
   if(mng)
   {
    l -= mng;				/* Riduco di un carattere */
    for(k = i; k < l; k++)
     intxt[k] = intxt[k+mng];
    intxt[k] = 0;
   }
  }
 }

 return intxt;
}


void set_testo(char * const strn, GtkWidget * form, const char * name, int mode)
{
 GtkWidget * text;

 // g_print("\nSet testo started: \n\"%s\"", strn);
 g_print("\nSet testo started");

 text = lookup_widget (form, name);
 if ( !strcmp(strn,"") )
 {
  Status[S_TESTO] = 0;
  gtk_editable_delete_text (GTK_EDITABLE (text), 0, -1);
 }
 else 
 {
  Status[S_TESTO] = mode;
  if (mode == TXT_REPLACE || mode == TXT_CLEAN)
   gtk_editable_delete_text (GTK_EDITABLE (text), 0, -1);
  if( mode != TXT_CLEAN )
   gtk_text_insert (GTK_TEXT (text), FixedFont, NULL, NULL, M_STRDUP(strn), -1); 		/* strlen(strn)	*/
 }
}


void stampa_infos(void)
{
 int i;
 char stex[NUM_STATUS_FLAGS][20] = { "", "S_TESTO",  "S_RICERCA", "S_RUBRICA",  "S_BUFFER", 
                                         "S_CARDS",  "S_LISTA",   "S_ORDINE",   "S_SELISTA", 
                                         "S_CAMPI",  "S_INIBIT",  "S_SELCAMPO", "S_MODIFICA", 
                                         "S_INFO",   "S_CMPMOD",  "S_CONFMOD",  "S_KEYSHIFT",
                                         "S_CRDMOD", "S_AVVRTM",  "S_TELEFONO", "S_MODEM",
                                         "S_MTERM",  "S_BACKUP",  "S_SEQUENZA", "S_SEQMOD",
                                         "S_FILEDIALOG" };

 for (i = 1; i < NUM_STATUS_FLAGS; i++)
  if(stex[i][0])
   g_print("\n%s: %d", stex[i], Status[i]);
}


void show_error_msg (const char * errmsg)
{
 GtkWidget * messaggio;

 g_print("\n\n%s\n", errmsg);

 Msg_Errore = create_errore();
 messaggio = lookup_widget(Msg_Errore, "error_msg");
 gtk_label_set (GTK_LABEL(messaggio), errmsg);
 MOSTRA_ON_MOUSE(Msg_Errore);
}


void show_info_msg (void)
{
 GtkWidget * messaggio;
 char * infomsg;

 infomsg = (char *)malloc(strlen(RVERSN)+strlen(AUTHOR)+strlen(EMAIL)+strlen(WEBPAGE)+16);
 if( infomsg )
 {
  sprintf(infomsg, "\n%s\n\n%s\n%s\n%s\n", RVERSN, AUTHOR, EMAIL, WEBPAGE);
  Info = create_informazioni();
  messaggio = lookup_widget(Info, "infolabel");
  gtk_label_set (GTK_LABEL(messaggio), infomsg);
 }
 else
  Info = create_informazioni();

 MOSTRA_ON_MOUSE(Info);
 return;
}


char * genera_sequenza_standard(void)
{
 char * seq, * strn;
 int i, j, len = 0, lun = 0;

 /* Si dovrebbe scrive un controllo
    sull'esistenza di tutti i Capi[i] */
 g_print("\nGenera sequenza standard started");

 for(i = 1; i < Status[S_CAMPI]; i++)
 {
  lun = strlen(Campi[i]);
  len = (len < lun) ? lun : len;
 }
 lun = len;		/* Lunghezza massima un campo */
 len = 2*lun + 8;       /* Lunghezza complessiva di ogni porzione di sequenza */

 seq = (char *)malloc(len*Status[S_CAMPI] + 10);
 strn = (char *)malloc(len);
 if(seq == NULL || strn == NULL)
 {
  g_print("\nERRORE: genera_sequenza_standard puntatore nullo");
  return NULL;
 }

 sprintf(seq, "#seq: \"");
 for(i = 1; i < Status[S_CAMPI]; i++)
 {
  sprintf(strn,"%s%s", (i > 1) ? "\\n" : "", Campi[i]);
  for(j = strlen(Campi[i]); j < lun; j++)
   sprintf(strn,"%s ", strn);

  sprintf(strn,"%s: %c%s%c", strn, '%', Campi[i], '%');
  sprintf(seq, "%s%s", seq, strn);
 }
 sprintf(seq, "%s\"", seq);

 g_print("\nSequenza (%d/%d): \n", strlen(strn), len);
 g_print("\n%s", seq);
 M_FREE(strn);

 return seq;
}


char * genera_intestazione(void)
{
 char * intsz;
 int i, len;

 /* Si dovrebbe scrive un controllo
    sull'esistenza di tutti i Capi[i] */
 g_print("\nGenera intestazione started");

 len = strlen("\"Codice\"\t") + 10;
 for(i = 1; i < Status[S_CAMPI]; i++)
  len = len + strlen(Campi[i]) + 3;

 /* Per stare tranquilli metto 10 bytes di piu` */
 intsz = (char *)malloc(len + 10);
 if( intsz != NULL )
 {
  sprintf(intsz, "\"Codice\"\t");
  for(i = 1; i < Status[S_CAMPI]; i++)
   sprintf(intsz, "%s\"%s\"\t", intsz, Campi[i]);
  sprintf(intsz, "%s\n", intsz);

  g_print("\nIntestazione: (%d/%d)", strlen(intsz), len);
  g_print("\n%s", intsz);
 }
 else
  g_print("\nERRORE: genera_intestazione puntatore nullo");

 return intsz;
}


char * genera_voce_vuota(void)
{
 char * voce;
 int i, len;

 /* Si dovrebbe scrive un controllo
    sull'esistenza di tutti i Capi[i] */
 g_print("\nGenera voce vuota started");

 len = strlen("\"#001\"\t") + Status[S_CAMPI]*strlen("\"_\"\t") + 10;
 voce = (char *)malloc(len);
 if( voce != NULL )
 {
  sprintf(voce, "\"#001\"\t");
  for(i = 1; i < Status[S_CAMPI]; i++)
   sprintf(voce, "%s\"_\"\t", voce);
  sprintf(voce, "%s\n", voce);

  g_print("\nVoce vuota (%d/%d):", strlen(voce), len);
  g_print("\n%s", voce);
 }
 else
  g_print("\nERRORE: genera_voce puntatore nullo");

 return voce;
}


char * duplica_sequenza(char * const ins)
{
 int i;
 char * ptxt = NULL;
 
 i = 0; /* trovo il primo doppio apice */ 
 while(ins[i] != '"') 
 {
  /* La sequenza passata per essere copiata deve
     essere puro testo altrimenti vuol dire che e`
     stata corrotta */
  if( !ins[i] )
   return NULL;
  else
   i++;
 }

 i++; /* trovo il secondo doppio apice */
 while(ins[i] != '"') 
 {
  /* La sequenza dovrebbe essere testuale ma e` possibile
     che il doppio apice di chiusura manchi in tal caso
     si cerca di arginare il problema */
  if( !ins[i] )
   break;
  else
   i++;
 }
 
 /* La stringa deve terminare con un carettere nullo */
 ptxt = (char *)malloc(i+16);
 strncpy(ptxt, ins, i+1);  
 ptxt[i+1] = 0;
 
 return ptxt;
}



/******************************* FUNZIONI DI RICERCA E SOSTITUZIONE *************************************/

long find_first(char * buffer, const char * find, int mode)
{
 long l, len;
 int lun, stop = 1;

 g_print("\nfind_first %s:", find);

 lun = (int)strlen(find);
 len = (long)strlen(buffer) - lun;

 /* Se il buffer e` piu` corto della stringa
    da ricercare oppure se la stringa da
    ricercare e nulla non serve fare la ricerca */
 if(len < 0 || lun < 1)
  return -1;

 switch(mode)
 {
  case (IGN_CASE | REVERSE):
  		for(l = len+lun; l >= lun  && stop; l--)
                 if( find[0] == buffer[l] )
   		   if( len == 1 || !strncasecmp(find, (char *)&buffer[l], lun) )
    		    stop = 0;
    		 break;

  case (CASE_SEN | REVERSE):
  		for(l = len+lun; l >= lun  && stop; l--)
                 if( find[0] == buffer[l] )
   		   if( len == 1 || !strncmp(find, (char *)&buffer[l], lun) )
    		    stop = 0;
    		 break;

  case IGN_CASE: for(l = 0; l <= len && stop; l++)
  		  if( find[0] == buffer[l] )
   		   if( len == 1 || !strncasecmp(find, (char *)&buffer[l], lun) )
    		    stop = 0;
    		 break;

  case CASE_SEN:
  default:	 for(l = 0; l <= len && stop; l++)
  		  if( find[0] == buffer[l] )
   		   if( len == 1 || !strncmp(find, (char *)&buffer[l], lun) )
    		    stop = 0;
    		 break;
 }

 /* Se ha trovato una ocrrispondenza ritorna l'offset
    altrimenti ritorna la lunghezza del buffer negativa */
 return (stop) ? -len-lun : l;
}


struct s_int { long idx;
               struct s_int * nxt; };
int replace_in_sequenza(const char * old, const char * new, int type)
{
 struct s_int si, * sc, *sn;
 long l, n, * pt, wi, ri, len1, len2, len3, lun, d;
 char * newseq, * newa, * olda;
 int modo;

 /* Inutile chiamare questa funzione se la stringa
    da sostituire e` nulla oppure se e` uguale */
 if( !strcmp (old, new) || !strcmp(old, ""))
  return 0;

 g_print("\nreplace_in_sequenza started ");
 if(type == FR_CAMPI)
 {
  if( strcmp(new, "") )
  {
   newa = (char *)malloc(strlen(new) + 4);
   sprintf(newa, "%%%s%%", new);
  }
  else newa = NULL; 
  olda = (char *)malloc(strlen(old) + 4);
  sprintf(olda, "%%%s%%", old);
  modo = IGN_CASE;
 }
 else
 {
  if( strcmp(new, "") )
   newa = M_STRDUP(new);
  else
   newa = NULL; 
  olda = M_STRDUP(old);
  modo = CASE_SEN;
 }
 g_print("[%s->%s]:", olda, (newa != NULL) ? newa : "");

 /* Trovo tutti gli offset */
 n = 0;
 lun = 0;
 si.idx = -1;
 si.nxt = NULL;
 sc = &si;
 do {
  l = find_first(&Sequenza[lun], olda, modo);
  g_print(" %ld, %ld,", lun, l);
  if (l >= 0) lun += l;
  g_print(" seq[%ld]=\"%s\"", lun, &Sequenza[lun]);

  sc->idx = (l >= 0) ? lun : l;
  sc->nxt = (struct s_int *)malloc(sizeof(struct s_int));
  sc = sc->nxt;
  sc->nxt = NULL;
  n++;
  lun++;
 } while(l >= 0);

 /* Se non ne ho trovati ritorno */
 if(n == 1 && si.idx < 0) return 0;

 /* Smatasso la lista degli offset in un vettore
    ricordandomi che l'ultimo offset e` sempre negativo
    ma lasciandolo come identificativo di fine vettore */
 sc = &si;
 pt = (long *)malloc(sizeof(long)*n);
 for(l = 0; l < n; l++)
 {
  pt[l] = sc->idx;
  sn = sc;
  sc = sc->nxt;
  if(sn != &si && sn != NULL) free(sn);
 }
 g_print("\nTrovate %ld ricorrenze", n-1);
 
 /* Costruisco un nuovo buffer degno di ricevere la sequenza modificata */
 n--;
 len2 = (newa) ? strlen(newa) : 0;
 d = len2 - (len1 = strlen(olda));
 len3 = strlen(Sequenza) + 16;				/* 16 bytes di sicurezza */
 if (d > 0) len3 += d*n;
 newseq = (char *)malloc(len3);
 if (newseq == NULL) return -1;
 g_print("\nlen1: %ld, len2: %ld, len3: %ld, d: %ld, str: %d", len1, len2, len3, d, strlen(Sequenza));

 /* Scrivo il nuovo buffer copiando ora dal vecchio ora dalla stringa */
 wi = 0; ri = 0;
 for(l = 0; l < n; l++)
 {
  lun = pt[l] - ri - 1;
  if(lun) memcpy(&newseq[wi], &Sequenza[ri], lun);
  g_print("\nwi: %ld, ri: %ld, ln: %ld", wi, ri, lun);
  ri += lun + len1;

  wi += lun;
  if(newa != NULL)
  {
   memcpy(&newseq[wi], newa, len2);
   wi += len2;
  } 
 }
 lun = strlen(Sequenza) - ri;
 if(lun)
  memcpy(&newseq[wi], &Sequenza[ri], lun);
 newseq[wi+lun] = 0;

 /* Faccio pulizia delle stringhe ormai inutili */
 M_FREE(newa);
 M_FREE(olda);
 
 /* Sostituisco la sequenza */
 M_FREE(Sequenza);
 Sequenza = newseq;

 return n;
}
